/********************************************* 
	File "main.c"
	Simulated Annealing
	Santiago Gonzalez Tortosa
	Athens Course 2005
	Facultad de Informatica
	Universidad Politecnica de Madrid
**********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include "sa.h"
#include "r250.h"

// We define length of data
#define len 5


// Number of Iterations
#define MAXIT 400

//Initial Temperature
#define TEMPINI 0.1


//Final Temperature 
#define TEMPFIN 0.0001


// Convergence
#define CONVERGE 250



/* the fitness function */
double fitness(void* data){
	int value=0;
	double f;
	int *x;

	x = (int *)data;
	// Get the integer value of the binary solution
	value = 16 * (int)x[0] + 8 * (int)x[1] + 4 * (int)x[2] + 2*(int)x[3] + 1 * (int)x[4];
	// Fitness function: x^3 - 60x^2 + 900x + 100
	f = (double)(pow(value,3) - 60 * pow(value,2) + 900 * value + 100);
	
	return f;
}


/* uniform random number */
double get_R(){
	double r;

	r = 0.05;
	
	return r;
}



/* Cooling schedule */
double cooling(double temp,int iteration){
	double res,aux;

	aux = iteration*((TEMPINI-TEMPFIN)/MAXIT); /* in this case Ti = To - (i*(To-Tn)/N) */
	res = TEMPINI - aux;
	
	return res;
}



/* Get initial data 
void *get_data(){
	void *res;

	res = malloc(len * sizeof(int));

	return res;
}*/



/* initialite SA */
void *SAinitial(void *data){

	int *res,i;

	res =(int *) data;

	for (i=0; i<len; i++) 
		res[i] = r250(2);

	return (void *)res;
}



/* Modifing data with mutation or cross */
void *SAchange(void *data){

	int i,j;
	int *res, *aux;

	aux = (int *)data;
	res=malloc(len*sizeof(int));
	
	i = r250(len);
	for (j = 0; j < len; j++){
		if (i == j){
				res[j] = ( (int)aux[j] + 1 ) % 2;
		}else{
			res[j] = (int)aux[j];
		}
	}
	return (void *)res;
}



/* Eval new data */
double SAeval(void *data){
	double res;

	res = fitness(data);

	return res;
}



/* Factor of Convergence */
bool SAConverge(long i, double temp, double temp_fin){
	
	// in this case, temp < TEMPFIN
	return ((temp <= temp_fin) || (i == MAXIT));
}




/* Represent the final SA solution */
void SAPresent(long i,void *best,double fbest){

	int j;
	int *aux;

	aux = (int *) best;

	printf("\n\nFINAL:\tITERATION:%d\tVAL:",i);
	for (j=0;j<len;j++){
		printf("%d ",(int)aux[j]);
	}
	printf("\tFITNESS VALUE:%f\n",fbest);
	system("pause");
}



/* Main Function */
int main(int argc, char **argv){

	int *data;

	// In this case we don't need arguments for main

	// Get the initial data
	//data = get_data();
	data = malloc(len * sizeof(int));

	// Execute Simulated Annealing
	SA(data,TEMPINI, TEMPFIN);

	return 0;
}
