/********************************************* 
	File "sa.c"
	Simulated Annealing
	Santiago Gonzalez Tortosa
	Athens Course 2005
	Facultad de Informatica
	Universidad Politecnica de Madrid
**********************************************/


#include "sa.h"
#include "r250.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>


double fitness(void* data);
double get_R();
double cooling(double temp,int iteration);


/* Simulated annealing */
void SA(void *data, double temp_ini, double temp_fin){

	long i,noChange=0;
	double fbest, fnow,temp;
	void *best,*now;
	bool worst;



	temp = temp_ini;

	// Initialize random generation
	r250_init(112);

	// Initializate Simulated Annealing
	best=SAinitial(data);
	fbest=SAeval(best);


	for (i=0;;i++){
		worst=false;
		now=SAchange(best);
		fnow=SAeval(now);
		temp=cooling(temp,i);


		if ((fbest < fnow) || (get_R() < exp(fbest-fnow / temp)) ) {
			if (fbest > fnow) worst=true;
			free(best);
			best = now;
			fbest = fnow;
			noChange=0;
		}else noChange++;

        printf("Iteration %d\tno Change:%d\tworst:%d\tTemperature:%f\tFitness:%f\n",i,noChange,worst,temp,fbest);
		//system("pause");

		if (SAConverge(i,temp,temp_fin)) break;
	}
	
	SAPresent(i,best,fbest);
}